## ouistiti-project-ouistiti.zip

=== Makefile ===
package=ouistiti
version=3.5
includedir=$(prefix)/include/$(package)

include scripts.mk

CFLAGS+=-I$(srcdir)/include/ouistiti
export CFLAGS
#libhttpserver has to be static in all configuration
export SLIB_HTTPSERVER=y

ifeq ($(VTHREAD_TYPE),pthread)
 USE_PTHREAD=y
endif

download-$(LIBHTTPSERVER_DL)+=libhttpserver
libhttpserver_SOURCE=libhttpserver
libhttpserver_SITE=https://github.com/ouistiti-project/libhttpserver.git
libhttpserver_SITE_METHOD=git

LIBHTTPSERVER_DIR?=libhttpserver
export LIBHTTPSERVER_DIR

ifneq ($(wildcard $(LIBHTTPSERVER_DIR)/Makefile),)
subdir-y+=$(LIBHTTPSERVER_DIR)
LIBHTTPSERVER_LDFLAGS+=-L$(builddir)$(LIBHTTPSERVER_DIR)/src/ -L$(builddir)$(LIBHTTPSERVER_DIR)/src/httpserver
LIBHTTPSERVER_LDFLAGS+=-L${hostobjdir}$(LIBHTTPSERVER_DIR)/src/ -L${hostobjdir}$(LIBHTTPSERVER_DIR)/src/httpserver
LIBHTTPSERVER_CFLAGS=-I$(srcdir)$(LIBHTTPSERVER_DIR)/include
endif
LIBHTTPSERVER_NAME:=$(package)
export LIBHTTPSERVER_NAME
export LIBHTTPSERVER_LDFLAGS
export LIBHTTPSERVER_CFLAGS

ifneq ($(HTTPCLIENT_FEATURES),y)
override AUTHN_OAUTH2:=n
endif

include-y+=config.h
include-y+=version.h
subdir-y+=include/ouistiti
subdir-y+=staging
subdir-y+=src
subdir-y+=utils
subdir-$(WEBCOMMON)+=www

=== packages/Makefile ===
SPECFILE:=./rpmbuild/ouistiti.spec
package=ouistiti
version=$(shell grep '^version[?,:, ]*=' ../Makefile | awk 'BEGIN{FS="="}{print $$2}')

RPMDIR?=$(HOME)
UID=$(shell id -u)

DOCKER_ARG?=--no-cache
.PHONY: FORCE

debian: FORCE
	@dpkg-buildpackage --no-sign

debian-docker: FORCE
	@docker build -t ouistiti-debian $(DOCKER_ARG) debian/
	@docker run -v .:/mnt ouistiti-debian

rpm-docker: FORCE
	@docker build -t ouistiti-rpm $(DOCKER_ARG) rpmbuild/
	@docker run -v .:/mnt ouistiti-rpm

$(RPMDIR)/rpmbuild/SOURCES:
	@mkdir -p $@

$(RPMDIR)/rpmbuild/SOURCES/$(package)-$(version).tar.gz: $(RPMDIR)/rpmbuild/SOURCES
	@make -C .. distclean
	@tar -cz --exclude=.git --exclude=.config* --exclude=package --exclude=rpmbuild .. > $@

rpm: $(RPMDIR)/rpmbuild/SOURCES/$(package)-$(version).tar.gz FORCE
	@rpmbuild -ba $(SPECFILE)

DOCKERFILE:=docker/Dockerfile
DOCKERTARGET:=ouistitiproject/$(package)
docker/libouistiti_latest_amd64.deb: URL=$(shell  wget https://api.github.com/repos/ouistiti-project/libhttpserver/releases/latest -q -O - | awk '/browser_download_url/{print $$2}')
docker/libouistiti_latest_amd64.deb:
	@echo "  "WGET $@
	@wget $(URL) -O $@
docker/ouistiti_latest_amd64.deb: URL=$(shell  wget https://api.github.com/repos/ouistiti-project/ouistiti/releases/latest -q -O - | awk '/browser_download_url/{print $$2}')
docker/ouistiti_latest_amd64.deb:
	@echo "  "WGET $@
	@wget $(URL) -O $@
docker-build: docker/libouistiti_latest_amd64.deb docker/ouistiti_latest_amd64.deb
	@docker build --file $(DOCKERFILE) --build-arg UID=$(UID) -t $(DOCKERTARGET) $(dir $(DOCKERFILE))

docker: FORCE
	@docker run --net=host -v $(PWD):/srv $(DOCKERTARGET)

=== src/Makefile ===
ifneq ($(AUTH), y)
AUTHN_NONE=n
AUTHN_BASIC=n
AUTHN_DIGEST=n
AUTHZ_SIMPLE=n
AUTHZ_FILE=n
AUTHZ_UNIX=n
AUTHZ_SQLITE=n
endif

ifneq ($(DOCUMENT), y)
SENDFILE=n
DOCUMENTREST=n
DIRLISTING=n
RANGEREQUEST=n
DOCUMENTHOME=n
endif

TARGET?=$(package)
sbin-y+=$(TARGET)
ifeq ($(VTHREAD_TYPE),pthread)
$(TARGET)_LIBS-$(VTHREAD)+=pthread rt
endif
$(TARGET)_SOURCES+=main.c
$(TARGET)_SOURCES+=stringscollection.c
ifneq ($(MODULES),y)
$(TARGET)_SOURCES-$(STATIC)+=ouistiti_static.c
endif
$(TARGET)_SOURCES-$(MODULES)+=ouistiti_modules.c
$(TARGET)_SOURCES+=daemonize.c
$(TARGET)_LIBS+=$(LIBHTTPSERVER_NAME)
$(TARGET)_LIBS+=ouistiti
$(TARGET)_LIBS+=ouiutils

$(TARGET)_LDFLAGS+=$(LIBHTTPSERVER_LDFLAGS)
$(TARGET)_CFLAGS+=$(LIBHTTPSERVER_CFLAGS)

$(TARGET)_LDFLAGS+=-L$(srcdir)staging
$(TARGET)_CFLAGS+=-I$(srcdir)staging

$(TARGET)_SOURCES-$(FILE_CONFIG)+=config.c
$(TARGET)_LIBRARY-$(FILE_CONFIG)+=libconfig

$(TARGET)_LIBS-$(MODULES)+=dl

ifneq ($(MODULES),y)
$(TARGET)_LIBS-$(MBEDTLS)+=mod_mbedtls
$(TARGET)_LIBS-$(WOLFSSL)+=mod_wolfssl
$(TARGET)_LIBS-$(OPENSSL)+=mod_openssl
$(TARGET)_LIBS-$(DOCUMENT)+=mod_document
$(TARGET)_LIBS-$(CGI)+=mod_cgi
$(TARGET)_LIBS-$(AUTH)+=mod_auth
$(TARGET)_LIBS-$(AUTHZ_MANAGER)+=mod_authmngt
$(TARGET)_LIBS-$(VHOST)+=mod_vhost
$(TARGET)_LIBS-$(METHODLOCK_DEPRECATED)+=mod_methodlock
$(TARGET)_LIBS-$(WEBSOCKET)+=mod_websocket
$(TARGET)_LIBS-$(SERVERHEADER)+=mod_server
$(TARGET)_LIBS-$(CLIENTFILTER)+=mod_clientfilter
$(TARGET)_LIBS-$(USERFILTER)+=mod_userfilter
$(TARGET)_LIBS-$(REDIRECT)+=mod_redirect404
$(TARGET)_LIBS-$(REDIRECT)+=mod_redirect
$(TARGET)_LIBS-$(WEBSTREAM)+=mod_webstream
$(TARGET)_LIBS-$(COOKIE)+=mod_cookie
$(TARGET)_LIBS-$(CORS)+=mod_cors
$(TARGET)_LIBS-$(TINYSVCMDNS_DEPRECATED)+=mod_tinysvcmdns
$(TARGET)_LIBS-$(UPGRADE)+=mod_upgrade

$(TARGET)_LIBS-$(MBEDTLS)+=mbedtls mbedx509 mbedcrypto
$(TARGET)_LIBRARY-$(WOLFSSL)+=wolfssl
$(TARGET)_LIBRARY-$(OPENSSL)+=libssl libcrypto

$(TARGET)_LIBRARY-$(AUTHZ_SQLITE)+=sqlite3
$(TARGET)_LIBRARY-$(AUTHZ_UNIX)+=libcrypt
$(TARGET)_LIBRARY-$(AUTHZ_JWT)+=jansson
$(TARGET)_LIBRARY-$(AUTHN_OAUTH2)+=jansson
endif

$(TARGET)_LIBS-$(WEBSOCKET)+=ouibsocket
$(TARGET)_LIBS-$(WEBSOCKET)+=ouihash
$(TARGET)_LIBS-$(AUTH)+=ouihash

$(TARGET)_CFLAGS-$(MBEDTLS)+=-DTLS
$(TARGET)_CFLAGS-$(WOLFSSL)+=-DTLS
$(TARGET)_CFLAGS-$(OPENSSL)+=-DTLS

$(TARGET)_CFLAGS-$(DEBUG)+=-g -DDEBUG
$(TARGET)_LIBS-$(DEBUG)+=rt

subdir-$(CGI)+=mod_cgi.mk
subdir-$(COOKIE)+=mod_cookie.mk
subdir-$(DOCUMENT)+=mod_document.mk
subdir-$(AUTH)+=mod_auth.mk
subdir-$(MBEDTLS)+=mod_mbedtls.mk
subdir-$(OPENSSL)+=mod_openssl.mk
subdir-$(SERVERHEADER)+=mod_server.mk
subdir-$(CLIENTFILTER)+=mod_clientfilter.mk
subdir-$(REDIRECT)+=mod_redirect404.mk
subdir-$(REDIRECT)+=mod_redirect.mk
subdir-$(CORS)+=mod_cors.mk
subdir-$(WEBSOCKET)+=mod_websocket.mk
subdir-$(USERFILTER)+=mod_userfilter.mk
subdir-$(VHOST)+=mod_vhost.mk
subdir-$(WEBSTREAM)+=mod_webstream.mk

=== staging/Makefile ===
subdir-$(WEBSOCKET_RT)+=websocket.mk

subdir-$(DATE)+=mod_date.mk
subdir-$(FORMPARSER_DEPECATED)+=mod_formparser.mk
subdir-$(WOLFSSL)+=mod_wolfssl.mk
subdir-$(METHODLOCK_DEPRECATED)+=mod_methodlock.mk
subdir-$(TINYSVCMDNS_DEPRECATED)+=mod_tinysvcmdns.mk
subdir-$(UPGRADE)+=mod_upgrade.mk
subdir-$(PYTHON)+=mod_python.mk
subdir-$(FORWARD)+=mod_forward.mk
subdir-$(AUTHZ_MANAGER)+=mod_authmngt.mk

=== utils/Makefile ===
subdir-$(WEBSOCKET)+=websocket.mk
subdir-$(WEBSOCKET)+=client_websocket.mk
subdir-$(WEBSTREAM)+=webstream.mk

hostbin-$(HOST_UTILS)+=testclient
testclient_SOURCES+=testclient.c
testclient_LIBS-$(MBEDTLS)+=mbedtls mbedx509 mbedcrypto
testclient_CFLAGS-$(DEBUG)+=-g -DDEBUG

ifeq ($(HTTPCLIENT_FEATURES),y)
hostbin-$(HOST_UTILS_DEPRECATED)+=httpparser
endif
httpparser_SOURCES+=httpparser.c
httpparser_LIBS+=$(LIBHTTPSERVER_NAME)
httpparser_LDFLAGS+=$(LIBHTTPSERVER_LDFLAGS)
httpparser_CFLAGS+=$(LIBHTTPSERVER_CFLAGS)
httpparser_CFLAGS-$(DEBUG)+=-g -DDEBUG
httpparser_LDFLAGS+=-pthread

hostbin-$(HOST_UTILS)+=ouipasswd
ouipasswd_SOURCES+=ouipasswd.c
ouipasswd_LDFLAGS+=$(LIBHTTPSERVER_LDFLAGS)
ouipasswd_CFLAGS+=$(LIBHTTPSERVER_CFLAGS)
ouipasswd_LIBS+=ouihash
ouipasswd_LIBS-$(MBEDTLS)+=mbedcrypto
ouipasswd_LIBS-$(OPENSSL)+=crypto
ouipasswd_LIBS-$(WOLFSSL)+=wolfssl
ouipasswd_CFLAGS-$(DEBUG)+=-g -DDEBUG

hostbin-$(AUTHZ_TOTP)+=totp
totp_LDFLAGS+=$(LIBHTTPSERVER_LDFLAGS)
totp_CFLAGS+=$(LIBHTTPSERVER_CFLAGS)
totp_CFLAGS-$(DEBUG)+=-g -DDEBUG
totp_LIBS+=ouihash
totp_LIBRARY-$(MBEDTLS)+=mbedcrypto
totp_LIBRARY-$(OPENSSL)+=libcrypto
totp_LIBS-$(OPENSSL)+=crypto

sysconf-${FILE_CONFIG}+=ouistiti.conf
sysconf-${FILE_CONFIG}+=ouistiti.d/default.conf

subdir-$(CERTIFICATE)+=certificate.mk

data-y+=certificate.mk
data-y+=certificate.sh
data-y+=ca.conf

subdir-y+=samples.mk

=== www/Makefile ===
HTDOCS?=htdocs/
CGI_BIN?=cgi-bin/apps/
WEBSOCKET?=websocket/
WEBSTREAM?=webstream/
CERTDIR?=ssl/

data-y+=$(HTDOCS)index.html
data-y+=$(HTDOCS)common/js/jsonrpc.js
data-y+=$(HTDOCS)common/js/cmdbar.js
data-y+=$(HTDOCS)common/js/auth.js

BOOTSTRAP_DOCS?=htdocs/trust
JQUERY_DOCS?=htdocs/trust
export BOOTSTRAP_DOCS JQUERY_DOCS
subdir-$(BOOTSTRAP)+=bootstrap-5.mk
subdir-$(JQUERY)+=jquery.mk

data-$(GLYPHICONS)+=$(HTDOCS)trust/css/glyphicons.css
data-$(GLYPHICONS)+=$(HTDOCS)trust/fonts/glyphicons-halflings-regular.woff2

sysconf-y+=passwd.db
sysconf-y+=filter.db

hook-install-y+=websocket_dir
websocket_dir:
	mkdir -p $(DESTDIR)$(datadir)/$(WEBSOCKET)
hook-install-y+=webstream_dir
webstream_dir:
	mkdir -p $(DESTDIR)$(datadir)/$(WEBSTREAM)
hook-install-y+=conf_link
conf_link:
	rm -f $(DESTDIR)$(datadir)/conf
	ln -sf $(sysconfdir) $(DESTDIR)$(datadir)/conf
hook-install-y+=certs_link
certs_link:
	rm -f $(DESTDIR)$(datadir)/ssl
	ln -sf /etc/ssl/certs $(DESTDIR)$(datadir)/ssl

=== include/ouistiti/Makefile ===
include-y+=ouistiti.h

=== packages/debian/changelog ===
ouistiti (3.5.0-1) stable; urgency=low

  * updated modules: python

 -- Marc Chalain <marc.chalain@gmail.com> Tue, 31 Oct 2023 10:01:46 +0200

ouistiti (3.4.0-1) stable; urgency=low

  * Quality Gate crossing

 -- Marc Chalain <marc.chalain@gmail.com> Tue, 17 Oct 2023 14:10:11 +0200

ouistiti (3.3.0-1) unstable; urgency=low

  * new modules: python, forward
  * stabilized modules: openssl, webstream

 -- Développeur <developper@Corto>  Fri, 02 Jun 2023 10:12:02 +0200

ouistiti (3.2.1-1) stable; urgency=low

  * new libouistiti
  * module configuration
  * new vhost support
  * path_info of cgi
  * development sdk for external modules
  * new entries in configuration: init_d, include

 -- Marc Chalain <marc.chalain@gmail.com>  Sun, 12 Dec 2021 23:09:57 +0100

ouistiti (3.1.0-1) unstable; urgency=low

  * libhttpserver renamed libouistiti
  * libwebsocket renamed libouibsocket
  * -W to set the working directory
  * expiration managed by authentication
  * dirlisting on / URI
  * remove double / in the URI

 -- Marc Chalain <marc.chalain@gmail.com>  Thu, 11 Mar 2021 17:48:46 +0100

ouistiti (3.0-1) stable; urgency=medium

  * authentication
  * userfilter
  * user management

 -- Marc Chalain <marc.chalain@gmail.com>  Thu, 11 Mar 2021 17:48:46 +0100

=== packages/debian/control ===
Source: ouistiti
Section: universe/web
Priority: extra
Build-Depends: debhelper (>=9),
               libconfig-dev,
               libjansson-dev,
               libsqlite3-dev,
               libssl-dev (>=3.0.0),
               libpython3-dev (>=3.8)
Standards-Version: 4.0.0
Description: lightweight and fast HTTP server
Maintainer: Marc Chalain <marc.chalain@gmail.com>
Homepage: https://github.com/ouistiti-project/ouistiti

Package: ouistiti
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HTTP server for embedded devices
 Ouistiti is a small and fast HTTP server for embedded device.
 The goal of ouistiti is to host easily a server for configuration of the device.
 It offers services like authentication, websocket proxy or REST API on files.

Package: ouistiti-dev
Architecture: any
Multi-Arch: same
Section: devel
Depends: ouistiti, ${misc:Depends}, ${shlibs:Depends}
Description: header files for ouistiti HTTP server

Package: ouistiti-utils
Architecture: any
Section: net
Multi-Arch: same
Depends: ouistiti, ${misc:Depends}, ${shlibs:Depends}
Description: utils for ouistiti HTTP server
 Ouistiti-utils is a collection of sample applications for websocket server, password manager...

=== packages/debian/rules ===
#!/usr/bin/make -f

# Where we install every file before calling dh_install
DESTDIR := $(shell pwd)/debian/tmp
SRCDIR := .

MAKE_OPTIONS := package=ouistiti
CONFIG_FILE := threadpool_defconfig
CONFIG_OPTIONS := MJPEG=y WEBCOMMON=y prefix=/usr sysconfdir=/etc/ouistiti
MAKE_OPTIONS := LIBHTTPSERVER_NAME=ouistiti
%:
	dh $@

.PHONY: configure
override_dh_auto_configure:
	$(MAKE) -C $(SRCDIR) $(CONFIG_OPTIONS) $(MAKE_OPTIONS) $(CONFIG_FILE)

override_dh_auto_build-arch:
	$(MAKE) -C $(SRCDIR) $(MAKE_OPTIONS)

override_dh_auto_install:
	$(MAKE) -C $(SRCDIR) DESTDIR=$(DESTDIR) $(MAKE_OPTIONS) install
	mkdir -p $(DESTDIR)/srv/www/htdocs
	mkdir -p $(DESTDIR)/srv/www/cgi-bin
	mkdir -p $(DESTDIR)/srv/www/websocket
	mkdir -p $(DESTDIR)/srv/www/webstream

override_dh_auto_clean:
	$(MAKE) -C $(SRCDIR) distclean

override_dh_auto_test:
